//.pragma library

Qt.include("RenRenAccountManager.js")


var userInfo  =             //consumer
    {
    user_id: ""
    ,user_name: ""
    ,passwd: ""
    };



var req; //XMLHttpRequest
var photosetJson;
var photolistJson;
var photostreamPages;
var renrenGetAlbumsApiURL;
var accesstoken;
var currentSelectedAID



function renrenGetAccessToken()
{
    req = new XMLHttpRequest();
    req.onreadystatechange = renrenGetAccessTokenResponse;//parseFunc


    //debugText.text = "start renrenGetAccessToken"


    console.log("initiate database start");
    initDatabase();

   /*  userInfo.user_id="001";
    userInfo.user_name="iamjackfan@hotmail.com";
    userInfo.passwd= "111111";
    createConsumer(userInfo);
    console.log("initiate database end");*/


    userInfo.user_id="001";
    loadConsumer(userInfo);

    var url = "http://graph.renren.com/oauth/token?grant_type=password&username="+ userInfo.user_name +"&password="+userInfo.passwd +"&client_id=d544cc0cff5241059fef229d67c70aeb&client_secret=899056575ca7448aad7056dcc640ee75&scope=read_user_album read_user_photo";
    //这里不能用https, 否则release会不显示图片，让人faint的bug

    //var url = "https://graph.renren.com/oauth/token?grant_type=password&username=iamjackfan@hotmail.com" +"&password=111111"+"&client_id=d544cc0cff5241059fef229d67c70aeb&client_secret=899056575ca7448aad7056dcc640ee75&scope=read_user_album read_user_photo";
    req.open("POST", url, true);
    // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();
}



function renrenGetAccessTokenResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }


        console.log( req.responseText);


        var rsp=  req.responseText.toString();
        var accesstokenJson= JSON.parse(rsp);

        accesstoken= accesstokenJson["access_token"]

        appState.accessToken=accesstoken;

        renrenGetPhotoSets(0,accesstoken);

    }
}


function renrenGetPhotoSets(index,accessToken )
{
    var renrenIdNo;
    switch(index)
    {
    case 0:
        renrenIdNo= "414955024";
        break
    case 1:
        renrenIdNo= "418589362";
        break

    case 2:
        renrenIdNo= "418658928";
        break

    case 3:
        renrenIdNo= "418611733";
        break


    case 4:
        renrenIdNo= "418634515";
        break

    case 5:
        renrenIdNo= "418641275";
        break

    default:
        renrenIdNo= "414955024";
        break

    }

    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.getAlbums"
            ,"access_token=" + accessToken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"    // "243571487"     //224243671
        ];

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    renrenGetAlbumsApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");
    req = new XMLHttpRequest();
    req.onreadystatechange = renrenGetPhotoSetsResponse;//parseFunc

    req.open("POST", renrenGetAlbumsApiURL, true);
    // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}



function renrenGetPhotoSetsResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();
        photosetJson=  JSON.parse(rsp);


        if (photosetJson["error_code"]==undefined)
        {

            //tabContentID.formatRenrenAlbumListModel();

            switch (tabbedUIId.tabIndex)
            {
            case 0:
                zonghejingxuanTab.callformatRenrenAlbumListModel(photosetJson);
                break
            case 1:
                meixiongTab.callformatRenrenAlbumListModel(photosetJson);
                break

            case 2:
                changtuisiwaTab.callformatRenrenAlbumListModel(photosetJson);
                break

            case 3:
                xiangchemeinvTab.callformatRenrenAlbumListModel(photosetJson);
                break

            case 4:
                zhifuTab.callformatRenrenAlbumListModel(photosetJson);
                break

            case 5:
                mingxingTab.callformatRenrenAlbumListModel(photosetJson);
                break
            }
        }

       /* else
        {
            renrenGetPhotoSets(renrenGetAlbumsApiURL);
            console.log("get photoset return error code");
        }*/
    }
}



function renrenGetPhotos(renrenAID)
{

    var renrenIdNo;
    switch(tabbedUIId.tabIndex)
    {
    case 0:
        renrenIdNo= "414955024";
        break
    case 1:
        renrenIdNo= "418589362";
        break

    case 2:
        renrenIdNo= "418658928";
        break

    case 3:
        renrenIdNo= "418611733";
        break


    case 4:
        renrenIdNo= "418634515";
        break

    case 5:
        renrenIdNo= "418641275";
        break

    default:
        renrenIdNo= "414955024";
        break

    }


    currentSelectedAID= renrenAID;

    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.get"
            ,"access_token=" + accesstoken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"  //  "243571487"   //224243671
            ,"aid=" +renrenAID
        ];

    //

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    var renrenGetPhotosApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");

    console.log("API URL:"+ renrenGetPhotosApiURL);


    req = new XMLHttpRequest();
    req.onreadystatechange = renrenGetPhotosResponse;//parseFunc

    req.open("POST", renrenGetPhotosApiURL, true);
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}



function renrenGetPhotosResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();
        photolistJson=  JSON.parse(rsp);

        if (photolistJson["error_code"]==undefined)
        {
            switch (tabbedUIId.tabIndex)
            {
            case 0:
                zonghejingxuanTab.callformatRenrenPhotoListModel(photolistJson);
                break
            case 1:
                meixiongTab.callformatRenrenPhotoListModel(photolistJson);
                break


            case 2:
                changtuisiwaTab.callformatRenrenPhotoListModel(photolistJson);
                break


            case 3:
                xiangchemeinvTab.callformatRenrenPhotoListModel(photolistJson);
                break

            case 4:
                zhifuTab.callformatRenrenPhotoListModel(photolistJson);
                break

            case 5:
                mingxingTab.callformatRenrenPhotoListModel(photolistJson);
                break
            }

            //tabContentID.formatRenrenPhotoListModel();
            // zonghejingxuanTab.callformatRenrenPhotoListModel(photolistJson);
        }

       /* else
        {
            renrenGetPhotos(currentSelectedAID);
            console.log("get photos return error code");

        }*/


    }
}




function renrenShopGetPhotoSets(index,accessToken )
{
    var renrenIdNo;

    switch(index)
    {
    case 0:
        renrenIdNo= "422252130";
        break
    case 1:
        renrenIdNo= "424205029";
        break

    case 2:
        renrenIdNo= "424253337";
        break

    case 3:
        renrenIdNo= "424362868";
        break


    case 4:
        renrenIdNo= "398175933";
        break

    case 5:
        renrenIdNo= "422252130";
        break

    default:
        renrenIdNo= "422252130";
        break

    }


    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.getAlbums"
            ,"access_token=" + accessToken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"    // "243571487"     //224243671
        ];

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    renrenGetAlbumsApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");
    req = new XMLHttpRequest();
    req.onreadystatechange = renrenShopGetPhotoSetsResponse;//parseFunc

    req.open("POST", renrenGetAlbumsApiURL, true);
    // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}



function renrenShopGetPhotoSetsResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();
        photosetJson=  JSON.parse(rsp);


        if (photosetJson["error_code"]==undefined)
        {

            //tabContentID.formatRenrenAlbumListModel();


            switch (shoptabbedUIId.tabIndex)
            {
            case 0:
                shopTab1.callformatRenrenShopAlbumListModel(photosetJson);
                break
            case 1:
                shopTab2.callformatRenrenShopAlbumListModel(photosetJson);
                break

            case 2:
                shopTab3.callformatRenrenShopAlbumListModel(photosetJson);
                break

            case 3:
                shopTab4.callformatRenrenShopAlbumListModel(photosetJson);
                break

            case 4:
                shopTab5.callformatRenrenShopAlbumListModel(photosetJson);
                break

            case 5:
                shopTab6.callformatRenrenShopAlbumListModel(photosetJson);
                break
            }


        }

      /*  else
        {
            renrenShopGetPhotoSets(renrenGetAlbumsApiURL);
            console.log("get photoset return error code");
        }*/
    }
}


function renrenShopGetPhotos(renrenAID,accessToken)
{
    var renrenIdNo;
    switch(shoptabbedUIId.tabIndex)
    {
    case 0:
        renrenIdNo= "422252130";
        break
    case 1:
        renrenIdNo= "424205029";
        break

    case 2:
        renrenIdNo= "424253337";
        break

    case 3:
        renrenIdNo= "424362868";
        break

    case 4:
        renrenIdNo= "398175933";
        break

    case 5:
        renrenIdNo= "422252130";
        break

    default:
        renrenIdNo= "422252130";
        break

    }

    currentSelectedAID= renrenAID;

    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.get"
            ,"access_token=" + accessToken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"  //  "243571487"   //224243671
            ,"aid=" +renrenAID
        ];

    //

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    var renrenGetPhotosApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");

    console.log("API URL:"+ renrenGetPhotosApiURL);


    req = new XMLHttpRequest();
    req.onreadystatechange = renrenShopGetPhotosResponse;//parseFunc

    req.open("POST", renrenGetPhotosApiURL, true);
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}

function renrenShopGetPhotosResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();

        console.log("after rsp setting...");

        photolistJson=  JSON.parse( rsp);


        console.log("after photolistJson parse...");


        if (photolistJson["error_code"]==undefined)
        {

            switch (shoptabbedUIId.tabIndex)
            {
            case 0:
                shopTab1.callformatRenrenShopPhotoListModel(photolistJson);
                break
            case 1:
                shopTab2.callformatRenrenShopPhotoListModel(photolistJson);
                break

            case 2:
                shopTab3.callformatRenrenShopPhotoListModel(photolistJson);
                break

            case 3:
                shopTab4.callformatRenrenShopPhotoListModel(photolistJson);
                break

            case 4:
                shopTab5.callformatRenrenShopPhotoListModel(photolistJson);
                break

            case 5:
                shopTab6.callformatRenrenShopPhotoListModel(photolistJson);
                break
            }


        }

       /* else
        {
            renrenShopGetPhotos(currentSelectedAID);
            console.log("get photos return error code");

        }*/
    }
}





/*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;
/* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad = "";
/* base-64 pad character. "=" for strict RFC compliance   */

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_md5(s) {
    return rstr2hex(rstr_md5(str2rstr_utf8(s)));
}
function b64_md5(s) {
    return rstr2b64(rstr_md5(str2rstr_utf8(s)));
}
function any_md5(s, e) {
    return rstr2any(rstr_md5(str2rstr_utf8(s)), e);
}
function hex_hmac_md5(k, d) {
    return rstr2hex(rstr_hmac_md5(str2rstr_utf8(k), str2rstr_utf8(d)));
}
function b64_hmac_md5(k, d) {
    return rstr2b64(rstr_hmac_md5(str2rstr_utf8(k), str2rstr_utf8(d)));
}
function any_hmac_md5(k, d, e) {
    return rstr2any(rstr_hmac_md5(str2rstr_utf8(k), str2rstr_utf8(d)), e);
}

/**
 * exports function:

exports.hex_md5 = hex_md5;
exports.b64_md5 = b64_md5;
exports.any_md5 = any_md5;
exports.b64_hmac_md5 = b64_hmac_md5;
exports.hex_hmac_md5 = hex_hmac_md5;
exports.any_hmac_md5 = any_hmac_md5;

*/

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test() {
    return hex_md5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s) {
    return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Calculate the HMAC-MD5, of a key and some data (raw strings)
 */
function rstr_hmac_md5(key, data) {
    var bkey = rstr2binl(key);
    if (bkey.length > 16) bkey = binl_md5(bkey, key.length * 8);

    var ipad = Array(16), opad = Array(16);
    for (var i = 0; i < 16; i++) {
        ipad[i] = bkey[i] ^ 0x36363636;
        opad[i] = bkey[i] ^ 0x5C5C5C5C;
    }

    var hash = binl_md5(ipad.concat(rstr2binl(data)), 512 + data.length * 8);
    return binl2rstr(binl_md5(opad.concat(hash), 512 + 128));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input) {
    try {
        hexcase
    } catch(e) {
        hexcase = 0;
    }
    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var output = "";
    var x;
    for (var i = 0; i < input.length; i++) {
        x = input.charCodeAt(i);
        output += hex_tab.charAt((x >>> 4) & 0x0F)
                + hex_tab.charAt(x & 0x0F);
    }
    return output;
}

/*
 * Convert a raw string to a base-64 string
 */
function rstr2b64(input) {
    try {
        b64pad
    } catch(e) {
        b64pad = '';
    }
    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var output = "";
    var len = input.length;
    for (var i = 0; i < len; i += 3) {
        var triplet = (input.charCodeAt(i) << 16)
            | (i + 1 < len ? input.charCodeAt(i + 1) << 8 : 0)
            | (i + 2 < len ? input.charCodeAt(i + 2) : 0);
        for (var j = 0; j < 4; j++) {
            if (i * 8 + j * 6 > input.length * 8) output += b64pad;
            else output += tab.charAt((triplet >>> 6 * (3 - j)) & 0x3F);
        }
    }
    return output;
}

/*
 * Convert a raw string to an arbitrary string encoding
 */
function rstr2any(input, encoding) {
    var divisor = encoding.length;
    var i, j, q, x, quotient;

    /* Convert to an array of 16-bit big-endian values, forming the dividend */
    var dividend = Array(Math.ceil(input.length / 2));
    for (i = 0; i < dividend.length; i++) {
        dividend[i] = (input.charCodeAt(i * 2) << 8) | input.charCodeAt(i * 2 + 1);
    }

    /*
   * Repeatedly perform a long division. The binary array forms the dividend,
   * the length of the encoding is the divisor. Once computed, the quotient
   * forms the dividend for the next step. All remainders are stored for later
   * use.
   */
    var full_length = Math.ceil(input.length * 8 /
                                (Math.log(encoding.length) / Math.log(2)));
    var remainders = Array(full_length);
    for (j = 0; j < full_length; j++) {
        quotient = Array();
        x = 0;
        for (i = 0; i < dividend.length; i++) {
            x = (x << 16) + dividend[i];
            q = Math.floor(x / divisor);
            x -= q * divisor;
            if (quotient.length > 0 || q > 0)
                quotient[quotient.length] = q;
        }
        remainders[j] = x;
        dividend = quotient;
    }

    /* Convert the remainders to the output string */
    var output = "";
    for (i = remainders.length - 1; i >= 0; i--)
        output += encoding.charAt(remainders[i]);

    return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input) {
    var output = "";
    var i = -1;
    var x, y;

    while (++i < input.length) {
        /* Decode utf-16 surrogate pairs */
        x = input.charCodeAt(i);
        y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
        if (0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF) {
            x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
            i++;
        }

        /* Encode output as utf-8 */
        if (x <= 0x7F)
            output += String.fromCharCode(x);
        else if (x <= 0x7FF)
            output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                          0x80 | ( x & 0x3F));
        else if (x <= 0xFFFF)
            output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                          0x80 | ((x >>> 6 ) & 0x3F),
                                          0x80 | ( x & 0x3F));
        else if (x <= 0x1FFFFF)
            output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                          0x80 | ((x >>> 12) & 0x3F),
                                          0x80 | ((x >>> 6 ) & 0x3F),
                                          0x80 | ( x & 0x3F));
    }
    return output;
}

/*
 * Encode a string as utf-16
 */
function str2rstr_utf16le(input) {
    var output = "";
    for (var i = 0; i < input.length; i++)
        output += String.fromCharCode(input.charCodeAt(i) & 0xFF,
                                      (input.charCodeAt(i) >>> 8) & 0xFF);
    return output;
}

function str2rstr_utf16be(input) {
    var output = "";
    for (var i = 0; i < input.length; i++)
        output += String.fromCharCode((input.charCodeAt(i) >>> 8) & 0xFF,
                                      input.charCodeAt(i) & 0xFF);
    return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input) {
    var output = Array(input.length >> 2);
    for (var i = 0; i < output.length; i++)
        output[i] = 0;
    for (var i = 0; i < input.length * 8; i += 8)
        output[i >> 5] |= (input.charCodeAt(i / 8) & 0xFF) << (i % 32);
    return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input) {
    var output = "";
    for (var i = 0; i < input.length * 32; i += 8)
        output += String.fromCharCode((input[i >> 5] >>> (i % 32)) & 0xFF);
    return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len) {
    /* append padding */
    x[len >> 5] |= 0x80 << ((len) % 32);
    x[(((len + 64) >>> 9) << 4) + 14] = len;

    var a = 1732584193;
    var b = -271733879;
    var c = -1732584194;
    var d = 271733878;

    for (var i = 0; i < x.length; i += 16) {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;

        a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
        d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
        c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
        b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
        a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
        d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
        c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
        b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
        a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
        d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
        c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
        b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
        a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
        d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
        c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
        b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);

        a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
        d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
        c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
        b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
        a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
        d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
        c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
        b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
        a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
        d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
        c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
        b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
        a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
        d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
        c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
        b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);

        a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
        d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
        c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
        b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
        a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
        d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
        c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
        b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
        a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
        d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
        c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
        b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
        a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
        d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
        c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
        b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);

        a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
        d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
        c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
        b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
        a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
        d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
        c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
        b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
        a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
        d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
        c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
        b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
        a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
        d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
        c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
        b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);

        a = safe_add(a, olda);
        b = safe_add(b, oldb);
        c = safe_add(c, oldc);
        d = safe_add(d, oldd);
    }
    return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t) {
    return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
}
function md5_ff(a, b, c, d, x, s, t) {
    return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t) {
    return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t) {
    return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t) {
    return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y) {
    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt) {
    return (num << cnt) | (num >>> (32 - cnt));
}







var consumer  =
    {
    oauth_token: ""
    ,oauth_token_secret: ""
    ,oauth_verifier: ""
    ,user_id: ""
    ,user_name: ""
    ,passwd: ""
    ,provider: "sina"
    };

var provider =
    {
    name                       : "sina"
    ,appKey                    : "3445943910"
    ,appSecret                 : "72ef1a98b54cd8168ed972173ce5b98f"
    ,httpMethod                : "POST"
    ,signatureMethod           : "HMAC-SHA1"
    ,oauth_version             : "1.0"
    ,requestTokenURL           : "http://api.t.sina.com.cn/oauth/request_token"
    ,userAuthorizationURL      : "http://api.t.sina.com.cn/oauth/authorize"
    ,accessTokenURL            : "http://api.t.sina.com.cn/oauth/access_token"
    ,echoURL                   : "http://api.t.sina.com.cn/account/verify_credentials.json"
    ,timeLineURL               : "http://api.t.sina.com.cn/statuses/friends_timeline.json"
    ,updateURL                 : "http://api.t.sina.com.cn/statuses/update.json"
    ,repostURL                 : "http://api.t.sina.com.cn/statuses/repost.json"
    ,commentURL                 : "http://api.t.sina.com.cn/statuses/comment.json"
    , uploadURL                     : "http://api.t.sina.com.cn/statuses/upload.json"
    ,commentListURL                 :"http://api.t.sina.com.cn/statuses/comments.json"
    ,createFavorateURL              :"http://api.t.sina.com.cn/favorites/create.json"
    ,relationshipcheckURL           :"http://api.t.sina.com.cn/friendships/show.json"
    };

//"2031053539"
//"535a5cda165ae8b79f6ec8cbdcdc6edd"



function login(userName, passwd)
{
    console.log("beginning sign...");
    // AccMgr.clearDatabase();
    consumer.user_name = userName;
    consumer.passwd = passwd;


    connect(provider.requestTokenURL, null, false, requestParse);
}

function connect(url, addPara, addToUrl, parseFunc)
{
    var para = initPara(addPara);
    var baseString = provider.httpMethod+"&"+encodeURIComponent(url)+"&" + encodeURIComponent(para);
    console.log("basestring data:"+baseString);

    var signKey = provider.appSecret + "&" + consumer.oauth_token_secret;
    var signature =  b64_hmac_sha1(signKey, baseString);

    para = para + "&oauth_signature="+encodeURIComponent(signature) + "=";

    req = new XMLHttpRequest();
    req.onreadystatechange = parseFunc;
    if(addToUrl)
    {
        url = url + "?" + para;
    }
    console.log("url data:"+ url);
    req.open(provider.httpMethod, url, true);
    req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    if(addPara)
    {
        console.log("addPara data:"+addPara);
        req.send();


    }
    else
    {
        console.log("addPara is false");
        req.send(para);
    }
}


function requestParse()
{
    console.log("request Parse...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            //  profilePageID.onEchoResponsed(false);
            vipLoginInstance.showlogininfo();
            return;
        }

        console.log("requestParse...done!");
        console.log(req.responseText);
        var arr = req.responseText.split("&");
        consumer.oauth_token = arr[0].split("=")[1];
        consumer.oauth_token_secret = arr[1].split("=")[1];
        console.log("oauth_token: " + consumer.oauth_token);
        console.log("oauth_token_secret: " + consumer.oauth_token_secret);

        var url = provider.userAuthorizationURL + "?oauth_token=" + consumer.oauth_token + "&oauth_callback=json&userId=" +consumer.user_name + "&passwd=" + encodeURIComponent(consumer.passwd);
        console.log(url);
        req = new XMLHttpRequest();
        req.onreadystatechange = authParse;
        req.open("GET", url);
        req.send();
    }
}

function authParse()
{
    console.log("auth Parse...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            //profilePageID.onEchoResponsed(false);
            vipLoginInstance.showlogininfo();
            consumer.oauth_token="";
            consumer.oauth_token_secret="";
            consumer.oauth_verifier="";
            consumer.user_id="";


            return;
        }
        console.log("auth Parse...done!");
        console.log(req.responseText);
        var obj = JSON.parse(req.responseText);
        consumer.oauth_verifier = obj["oauth_verifier"];
        console.log("oauth_verifier: " + consumer.oauth_verifier);

        connect(provider.accessTokenURL, null, false, accParse);
    }
}

function accParse()
{
    console.log("acc Parse...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            //profilePageID.onEchoResponsed(false);
            vipLoginInstance.showlogininfo();
            consumer.oauth_token="";
            consumer.oauth_token_secret="";
            consumer.oauth_verifier="";
            consumer.user_id="";

            return;
        }
        console.log("acc Parse...done!");
        console.log(req.responseText);
        var arr = req.responseText.split("&");
        consumer.oauth_token = arr[0].split("=")[1];
        consumer.oauth_token_secret = arr[1].split("=")[1];
        consumer.user_id = arr[2].split("=")[1];
        console.log("oauth_token: " + consumer.oauth_token);
        console.log("oauth_token_secret: " + consumer.oauth_token_secret);
        console.log("user_id: " + consumer.user_id);

        //loginview.onAuthorized();
        // echoProfile();


        relationshipCheck()


    }
}

function relationshipCheck()
{
    console.log("relationship check start...");
    var addPara = ["target_id=2463394302"];   //target_id
    connect(provider.relationshipcheckURL, addPara, true, relationshipCheckParse);
}


function relationshipCheckParse()
{
    console.log("relationshipCheckParse start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            //profilePageID.onEchoResponsed(false);

            vipLoginInstance.showlogininfo();
            return;
        }
        console.log("request for profile...done!");
        console.log(req.responseText);
        var relationJson = JSON.parse(req.responseText);

        if (relationJson["source"]["followed_by"]==true)
        {
            console.log( "check success" )
            vipLoginInstance.opacity=0 ;
            viptabcontainer.opacity=1;
            viptabcontainer.focus=true;
            renrenVipGetPhotoSets(0, appState.accessToken )

        }

        else
        {
            console.log( "failed" )
            vipLoginInstance.showlogininfo();
            consumer.oauth_token="";
            consumer.oauth_token_secret="";
            consumer.oauth_verifier="";
            consumer.user_id="";

        }
    }
}


function renrenVipGetPhotoSets(index,accessToken )
{
    var renrenIdNo;
    switch(index)
    {
    case 0:
        renrenIdNo= "424367853";
        break
    case 1:
        renrenIdNo=    "424466144";  //   418589362
        break

    case 2:
        renrenIdNo= "424370309";
        break

    case 3:
        renrenIdNo= "424417780";
        break


    case 4:
        renrenIdNo= "425365507";
        break

    case 5:
        renrenIdNo= "425367983";
        break

    default:
        renrenIdNo= "424367853";
        break

    }

    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.getAlbums"
            ,"access_token=" + accessToken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"    // "243571487"     //224243671
        ];

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    renrenGetAlbumsApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");
    req = new XMLHttpRequest();
    req.onreadystatechange = renrenVipGetPhotoSetsResponse;//parseFunc

    req.open("POST", renrenGetAlbumsApiURL, true);
    // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}



function renrenVipGetPhotoSetsResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();
        photosetJson=  JSON.parse(rsp);


        if (photosetJson["error_code"]==undefined)
        {

            //tabContentID.formatRenrenAlbumListModel();

            switch (viptabbedUIId.tabIndex)
            {
            case 0:
                vipTab1.callformatRenrenAlbumListModel(photosetJson);
                break
            case 1:
                vipTab2.callformatRenrenAlbumListModel(photosetJson);
                break

            case 2:
                vipTab3.callformatRenrenAlbumListModel(photosetJson);
                break

            case 3:
                vipTab4.callformatRenrenAlbumListModel(photosetJson);
                break

            case 4:
                vipTab5.callformatRenrenAlbumListModel(photosetJson);
                break

            case 5:
                vipTab6.callformatRenrenAlbumListModel(photosetJson);
                break
            }
        }

      /*  else
        {
            renrenVipGetPhotoSets(renrenGetAlbumsApiURL);
            console.log("get photoset return error code");
        }*/
    }
}



function renrenVipGetPhotos(renrenAID)
{

    var renrenIdNo;
    switch(viptabbedUIId.tabIndex)
    {
    case 0:
        renrenIdNo= "424367853";
        break
    case 1:
        renrenIdNo=       "424466144";  //   418589362
        break

    case 2:
        renrenIdNo= "424370309";
        break

    case 3:
        renrenIdNo= "424417780";
        break


    case 4:
        renrenIdNo= "425365507";
        break

    case 5:
        renrenIdNo= "425367983";
        break

    default:
        renrenIdNo= "424419446";
        break

    }

    currentSelectedAID= renrenAID;

    var paraArray =
        [
            "api_key=" + "d544cc0cff5241059fef229d67c70aeb"
            ,"method="+ "photos.get"
            ,"access_token=" + accesstoken
            ,"format=" + "JSON"
            ,"v=" + "1.0"
            ,"uid=" + renrenIdNo //"414955024"  //  "243571487"   //224243671
            ,"aid=" +renrenAID
        ];

    //

    paraArray.sort();

    var signString= paraArray.join("");

    signString= signString+ "899056575ca7448aad7056dcc640ee75"

    console.log( signString);

    var sign= hex_md5(signString);

    paraArray.push("sig="+sign)

    var renrenGetPhotosApiURL= "http://api.renren.com/restserver.do?"+paraArray.join("&");

    console.log("API URL:"+ renrenGetPhotosApiURL);


    req = new XMLHttpRequest();
    req.onreadystatechange = renrenVipGetPhotosResponse;//parseFunc

    req.open("POST", renrenGetPhotosApiURL, true);
    req.setRequestHeader("Content-Encoding", "UTF-8");
    req.send();

}



function renrenVipGetPhotosResponse()
{
    console.log("renren response start...");
    if (req.readyState == XMLHttpRequest.HEADERS_RECEIVED)
    {

    }
    else if (req.readyState == XMLHttpRequest.DONE)
    {
        if(req.responseText.length == 0 || req.responseText == null)
        {
            return;
        }

        console.log( req.responseText);

        var rsp=  req.responseText.toString();
        photolistJson=  JSON.parse(rsp);

        if (photolistJson["error_code"]==undefined)
        {
            switch (viptabbedUIId.tabIndex)
            {
            case 0:
                vipTab1.callformatRenrenPhotoListModel(photolistJson);
                break
            case 1:
                vipTab2.callformatRenrenPhotoListModel(photolistJson);
                break


            case 2:
                vipTab3.callformatRenrenPhotoListModel(photolistJson);
                break


            case 3:
                vipTab4.callformatRenrenPhotoListModel(photolistJson);
                break

            case 4:
                vipTab5.callformatRenrenPhotoListModel(photolistJson);
                break

            case 5:
                vipTab6.callformatRenrenPhotoListModel(photolistJson);
                break
            }

            //tabContentID.formatRenrenPhotoListModel();
            // zonghejingxuanTab.callformatRenrenPhotoListModel(photolistJson);
        }

       /* else
        {
            renrenVipGetPhotos(currentSelectedAID);
            console.log("get photos return error code");

        }*/


    }
}





function timestamp()
{
    var t = (new Date()).getTime();// + correctTimestamp(12);
    return Math.floor(t / 1000);
}

var CHARS = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";

function nonce(length) {
    //return "13123123";
    var chars = CHARS;
    var result = "";
    for (var i = 0; i < length; ++i) {
        var rnum = Math.floor(Math.random() * chars.length);
        result += chars.substring(rnum, rnum+1);
    }
    return result;
}

function initPara(addPara)
{
    var paraArray =
        [
            "oauth_consumer_key=" + provider.appKey
            ,"oauth_signature_method=" + provider.signatureMethod
            ,"oauth_token=" + consumer.oauth_token
            ,"oauth_timestamp=" + timestamp()
            ,"oauth_nonce="+ "" + nonce(6)
            ,"oauth_version=" + provider.oauth_version
            ,"oauth_verifier=" + consumer.oauth_verifier
            ,"oauth_token_secret=" + consumer.oauth_token_secret
        ];

    if(addPara != null)
    {
        for(var p in addPara)
        {
            paraArray.push(addPara[p]);
        }
    }

    paraArray.sort();
    return paraArray.join("&");
}




/*
 * A JavaScript implementation of hmac-sha

 */

var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data){ return binb2b64(core_hmac_sha1(key, data));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
    return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
    /* append padding */
    x[len >> 5] |= 0x80 << (24 - len % 32);
    x[((len + 64 >> 9) << 4) + 15] = len;

    var w = Array(80);
    var a =  1732584193;
    var b = -271733879;
    var c = -1732584194;
    var d =  271733878;
    var e = -1009589776;

    for(var i = 0; i < x.length; i += 16)
    {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;
        var olde = e;

        for(var j = 0; j < 80; j++)
        {
            if(j < 16) w[j] = x[i + j];
            else w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
            var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                             safe_add(safe_add(e, w[j]), sha1_kt(j)));
            e = d;
            d = c;
            c = rol(b, 30);
            b = a;
            a = t;
        }

        a = safe_add(a, olda);
        b = safe_add(b, oldb);
        c = safe_add(c, oldc);
        d = safe_add(d, oldd);
        e = safe_add(e, olde);
    }
    return Array(a, b, c, d, e);

}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
    if(t < 20) return (b & c) | ((~b) & d);
    if(t < 40) return b ^ c ^ d;
    if(t < 60) return (b & c) | (b & d) | (c & d);
    return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
    return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
                                                           (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the HMAC-SHA1 of a key and some data
 */
function core_hmac_sha1(key, data)
{
    var bkey = str2binb(key);
    if(bkey.length > 16) bkey = core_sha1(bkey, key.length * chrsz);

    var ipad = Array(16), opad = Array(16);
    for(var i = 0; i < 16; i++)
    {
        ipad[i] = bkey[i] ^ 0x36363636;
        opad[i] = bkey[i] ^ 0x5C5C5C5C;
    }

    var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
    return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
    return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
    var bin = Array();
    var mask = (1 << chrsz) - 1;
    for(var i = 0; i < str.length * chrsz; i += chrsz)
        bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
    return bin;
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
    var str = "";
    var mask = (1 << chrsz) - 1;
    for(var i = 0; i < bin.length * 32; i += chrsz)
        str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
    return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var str = "";
    for(var i = 0; i < binarray.length * 4; i++)
    {
        str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
                hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
    }
    return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var str = "";
    for(var i = 0; i < binarray.length * 4; i += 3)
    {
        var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16)
            | (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 )
            |  ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
        for(var j = 0; j < 4; j++)
        {
            if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
            else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
        }
    }
    return str;
}



